diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index ed0ed089b..d71dc23ee 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -1,6 +1,5 @@
 package net.minecraft.client;
 
-import static net.minecraft.core.Global.*;
 import static org.lwjgl.opengl.GL11.*;
 
 import java.awt.Cursor;
@@ -9,53 +8,63 @@ import java.awt.event.MouseAdapter;
 import java.awt.event.MouseEvent;
 import java.io.File;
 import java.io.IOException;
-import java.net.HttpURLConnection;
-import java.net.URL;
 import java.util.ArrayList;
-import java.util.Comparator;
 import java.util.List;
+import java.util.Comparator;
 import java.util.Random;
+import java.net.HttpURLConnection;
+import java.net.URL;
+import java.util.*;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.client.entity.ClientSkinVariantList;
+import net.minecraft.client.gui.toasts.HudToastsElement;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.util.helper.LoggedPrintStream;
+import net.minecraft.core.util.helper.UUIDHelper;
+import net.minecraft.core.world.SpawnerMobs;
+import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypeGroups;
 
 import javax.swing.JLabel;
 import javax.swing.JOptionPane;
 
+import net.minecraft.client.gui.subtitles.SubtitleTracker;
 import net.minecraft.client.sound.SoundRepository;
 import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import org.jetbrains.annotations.Nullable;
+
 import org.lwjgl.LWJGLException;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
-import com.mojang.nbt.CompoundTag;
-
 import net.minecraft.client.discord.RichPresenceHandlerThread;
-import net.minecraft.client.entity.ClientSkinVariantList;
 import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
-import net.minecraft.client.gui.GuiBadJavaArch;
-import net.minecraft.client.gui.GuiChat;
-import net.minecraft.client.gui.GuiConflictWarning;
-import net.minecraft.client.gui.GuiConnecting;
-import net.minecraft.client.gui.GuiCreateWorld;
-import net.minecraft.client.gui.GuiException;
-import net.minecraft.client.gui.GuiGameOver;
-import net.minecraft.client.gui.GuiIngame;
-import net.minecraft.client.gui.GuiIngameMenu;
-import net.minecraft.client.gui.GuiInventory;
-import net.minecraft.client.gui.GuiInventoryCreative;
-import net.minecraft.client.gui.GuiMainMenu;
-import net.minecraft.client.gui.GuiMissingMinecraft;
-import net.minecraft.client.gui.GuiOutOfMemory;
-import net.minecraft.client.gui.GuiPhotoMode;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.GuiSelectWorld;
-import net.minecraft.client.gui.GuiSleepMP;
-import net.minecraft.client.gui.GuiSleepSP;
+import net.minecraft.client.gui.BadJavaArchScreen;
+import net.minecraft.client.gui.ChatScreen;
+import net.minecraft.client.gui.ConflictWarningScreen;
+import net.minecraft.client.gui.ConnectingScreen;
+import net.minecraft.client.gui.CreateWorldScreen;
+import net.minecraft.client.gui.ExceptionPopupElement;
+import net.minecraft.client.gui.GameOverScreen;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.PauseScreen;
+import net.minecraft.client.gui.container.InventoryScreen;
+import net.minecraft.client.gui.container.InventoryScreenCreative;
+import net.minecraft.client.gui.MainMenuScreen;
+import net.minecraft.client.gui.MissingMinecraftScreen;
+import net.minecraft.client.gui.OutOfMemoryScreen;
+import net.minecraft.client.gui.PhotoModeScreen;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.SelectWorldScreen;
+import net.minecraft.client.gui.SleepScreenMP;
+import net.minecraft.client.gui.SleepScreenSP;
 import net.minecraft.client.gui.MainMenuBackground;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
-import net.minecraft.client.gui.popup.GuiPopup;
-import net.minecraft.client.gui.toasts.GuiHudToasts;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.input.InputHandler;
 import net.minecraft.client.input.InputType;
@@ -69,17 +78,17 @@ import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerController;
-import net.minecraft.client.render.EffectRenderer;
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.FallbackRenderer;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.LoadingScreenRenderer;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.PostProcessingManager;
 import net.minecraft.client.render.RenderBlocks;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.RenderGlobal;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.WorldRenderer;
@@ -110,7 +119,6 @@ import net.minecraft.core.MinecraftError;
 import net.minecraft.core.MinecraftException;
 import net.minecraft.core.Timer;
 import net.minecraft.core.UnexpectedThrowable;
-import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.achievement.stat.StatsCounter;
 import net.minecraft.core.block.BaseLeavesBlock;
@@ -131,7 +139,6 @@ import net.minecraft.core.player.Session;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.helper.LogPrintStream;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.ScreenShot;
 import net.minecraft.core.util.helper.Side;
@@ -141,7 +148,6 @@ import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.PortalHandler;
-import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
 import net.minecraft.core.world.chunk.Chunk;
@@ -156,8 +162,27 @@ import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveConverters;
 import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
-import net.minecraft.core.world.type.WorldType;
-import net.minecraft.core.world.type.WorldTypeGroups;
+import org.slf4j.Logger;
+
+
+import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
+import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
+import static org.lwjgl.opengl.GL11.glAlphaFunc;
+import static org.lwjgl.opengl.GL11.glClear;
+import static org.lwjgl.opengl.GL11.glClearColor;
+import static org.lwjgl.opengl.GL11.glClearDepth;
+import static org.lwjgl.opengl.GL11.glColor4f;
+import static org.lwjgl.opengl.GL11.glCullFace;
+import static org.lwjgl.opengl.GL11.glDepthFunc;
+import static org.lwjgl.opengl.GL11.glDisable;
+import static org.lwjgl.opengl.GL11.glEnable;
+import static org.lwjgl.opengl.GL11.glLoadIdentity;
+import static org.lwjgl.opengl.GL11.glMatrixMode;
+import static org.lwjgl.opengl.GL11.glOrtho;
+import static org.lwjgl.opengl.GL11.glShadeModel;
+import static org.lwjgl.opengl.GL11.glTranslatef;
+import static org.lwjgl.opengl.GL11.glViewport;
 
 // Referenced classes of package net.minecraft.client:
 //            MinecraftApplet
@@ -165,6 +190,7 @@ import net.minecraft.core.world.type.WorldTypeGroups;
 public class Minecraft
     implements Runnable, MinecraftAccessor
 {
+    public static Logger LOGGER = LogUtils.getLogger();
     public static final String VERSION = Global.VERSION;
     public static final boolean isMultiplayerDisabled = false;
     public static boolean doPartialTick = true;
@@ -177,7 +203,7 @@ public class Minecraft
     public RenderGlobal renderGlobal;
     public LocalPlayer thePlayer;
     public ICamera activeCamera;
-    public EffectRenderer effectRenderer;
+    public ParticleEngine particleEngine;
     public Session session;
 
     public String worldPresetName = null;
@@ -188,23 +214,24 @@ public class Minecraft
     public String minecraftUri;
     public boolean hideQuitButton;
     public volatile boolean isGamePaused;
-    public RenderEngine renderEngine;
-    public FontRenderer fontRenderer;
+    public TextureManager textureManager;
+    public Font font;
     /**
      * Current gui the player is looking at
      * is null when in a world during normal play
      */
-    public @Nullable GuiScreen currentScreen;
+    public @Nullable Screen currentScreen;
     public LoadingScreenRenderer loadingScreen;
     public WorldRenderer worldRenderer;
     public ThreadDownloadResources downloadResourcesThread;
     private int ticksRan;
-    public GuiHudToasts guiAchievementToast;
-    public GuiIngame ingameGUI;
+    public HudToastsElement guiToasts;
+    public IngameHud ingameHud;
     public boolean skipRenderWorld;
     public HitResult objectMouseOver;
     public GameSettings gameSettings;
     public SoundEngine sndManager;
+    public final SubtitleTracker subtitleTracker = new SubtitleTracker();
     public TexturePackList texturePackList;
     private File mcDataDir;
     private ISaveFormat saveFormat;
@@ -253,7 +280,7 @@ public class Minecraft
     	this.gameWindow = gameWindow;
     	
         Global.accessor = this;
-        LogPrintStream.setup();
+        LoggedPrintStream.wrapStreams();
         hasCrashed = false;
         timer = new Timer(Global.TICKS_PER_SECOND);
         session = null;
@@ -262,7 +289,7 @@ public class Minecraft
         currentScreen = null;
         loadingScreen = new LoadingScreenRenderer(this);
         ticksRan = 0;
-        guiAchievementToast = new GuiHudToasts(this);
+        guiToasts = new HudToastsElement(this);
         skipRenderWorld = false;
         objectMouseOver = null;
         sndManager = new SoundEngine();
@@ -297,8 +324,7 @@ public class Minecraft
 		if(!gameStarted) {
 			running = false;
 
-			System.err.println("An exception has occured while trying to start the game!");
-			throwable.exception.printStackTrace(System.err);
+			LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
 			
 			gameWindow.displayCrashReport(throwable, 1);
 			hasCrashed = true;
@@ -310,8 +336,7 @@ public class Minecraft
 		if(disableCrashHandler) {
 			running = false;
 
-			System.err.println("An exception has occured, and the crash handler is disabled! The game will now exit!");
-			throwable.exception.printStackTrace(System.err);
+            LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
 			
 			gameWindow.displayCrashReport(throwable, 1);
 			hasCrashed = true;
@@ -321,9 +346,8 @@ public class Minecraft
 
 		if(hasCrashed) {
 			running = false;
-			
-			System.err.println("An exception has occured while trying to render the crash handler! The game will now exit!");
-			throwable.exception.printStackTrace(System.err);
+
+            LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
 			
 			gameWindow.displayCrashReport(throwable, 2);
 			shutdownMinecraftApplet();
@@ -331,26 +355,26 @@ public class Minecraft
 		}
 		
 		Debug.reset();
-		throwable.exception.printStackTrace(System.err);
+        LOGGER.error("Minecraft has crashed!", throwable.exception);
 		hasCrashed = true;
 		lastCrash = throwable;
 		
 		try {
             if (!gameStarted) {
-				GuiPopup error = GuiException.createStartupError(throwable.exception, this);
-				displayGuiScreen(error);
+				PopupScreen error = ExceptionPopupElement.createStartupError(throwable.exception, this);
+				displayScreen(error);
 				return;
 			}
 			if(throwable.exception instanceof RuntimeException) {
 				changeWorld(null);
-				GuiMainMenu guiMainMenu = new GuiMainMenu();
-				displayGuiScreen(guiMainMenu);
-				GuiPopup error = GuiException.create(guiMainMenu, throwable.exception, this);
-				displayGuiScreen(error);
+				MainMenuScreen mainMenuScreen = new MainMenuScreen();
+				displayScreen(mainMenuScreen);
+				PopupScreen error = ExceptionPopupElement.create(mainMenuScreen, throwable.exception, this);
+				displayScreen(error);
 			}else {
 				changeWorld(null);
-				GuiPopup error = GuiException.createFatal(throwable.exception, this);
-				displayGuiScreen(error);
+				PopupScreen error = ExceptionPopupElement.createFatal(throwable.exception, this);
+				displayScreen(error);
 			}
 		}catch (Throwable e) {
 			onMinecraftCrash(new UnexpectedThrowable("Trying to display crash handler", e));
@@ -365,7 +389,7 @@ public class Minecraft
     
     public void startGame() throws LWJGLException
     {
-        System.out.println("LWJGL version = " + org.lwjgl.Sys.getVersion());
+        LOGGER.info("LWJGL version = {}", org.lwjgl.Sys.getVersion());
         if (Integer.parseInt(org.lwjgl.Sys.getVersion().substring(0, 1)) < 3) {
             JOptionPane.showMessageDialog(null,
                 new Object[] {
@@ -381,7 +405,7 @@ public class Minecraft
                                     try {
                                         Desktop.getDesktop().browse(new URL("https://www.betterthanadventure.net/installation-guide/").toURI());
                                     } catch (Exception ex) {
-                                        ex.printStackTrace();
+                                        LOGGER.error("Exception occurred when attempting to open URL 'https://www.betterthanadventure.net/installation-guide/'!", ex);
                                     }
                                 }
                             });
@@ -405,8 +429,8 @@ public class Minecraft
 		GameResolution.defaultWidth = gameSettings.windowWidth.value;
 		GameResolution.defaultHeight = gameSettings.windowHeight.value;
 
-		System.out.println("Resolution: " + GameResolution.defaultWidth + " x " + GameResolution.defaultHeight);
-		System.out.println("Java Version: " + System.getProperty("java.version"));
+        LOGGER.info("Resolution: {} x {}", GameResolution.defaultWidth, GameResolution.defaultHeight);
+        LOGGER.info("Java Version: {}", System.getProperty("java.version"));
 
 		printWrongJavaVersionInfo();
 		
@@ -446,7 +470,7 @@ public class Minecraft
         }
 
         texturePackList = new TexturePackList(this, mcDataDir);
-        renderEngine = new RenderEngine(this, texturePackList, gameSettings);
+        textureManager = new TextureManager(this, texturePackList, gameSettings);
 
         SoundRepository.initialize(this);
 
@@ -467,20 +491,19 @@ public class Minecraft
         EntityRenderDispatcher.instance.itemRenderer = new ItemRenderer(this);
         loadScreen();	// Update loading screen so it doesn't say no response
 
-        System.out.println("Initializing input");
+        LOGGER.info("Initializing input");
         try {
             InputHandler.init(this);
 
             this.controllerInput = InputHandler.getController(gameSettings.selectedController.value);
         }catch (Exception e) {
-            System.err.println("Input init error!");
-            e.printStackTrace();
+            LOGGER.error("Input init error!", e);
         }
         mouseInput.setRawInput(gameSettings.rawMouseInput.value);
-        System.out.println("Input done!");
-        
-        System.out.println("Setting up OpenGL values...");
-        
+        LOGGER.info("Input done!");
+
+        LOGGER.info("Setting up OpenGL values...");
+
         OpenGLHelper.checkError("pre startup");
         glEnable(GL11.GL_TEXTURE_2D);
         glShadeModel(GL11.GL_SMOOTH);
@@ -500,26 +523,28 @@ public class Minecraft
         
         Colorizers.init(this);
         
-        renderEngine.refreshTextures(new ArrayList<>());
+        textureManager.refreshTextures(new ArrayList<>());
 
         loadScreen();	// Update loading screen so it doesn't say no response
-        
-        System.out.println("Initializing Renderer...");
+
+        LOGGER.info("Initializing Renderer...");
         
         TextureRegistry.blockAtlas.bind();
-        renderGlobal = new RenderGlobal(this, renderEngine);
+        renderGlobal = new RenderGlobal(this, textureManager);
         glViewport(0, 0, resolution.width, resolution.height);
-        effectRenderer = new EffectRenderer(theWorld, renderEngine);
+        particleEngine = new ParticleEngine(theWorld);
         try
         {
-            System.out.println("Starting Resource Download Thread...");
+            LOGGER.info("Starting Resource Download Thread...");
             downloadResourcesThread = new ThreadDownloadResources(mcDataDir, this);
             downloadResourcesThread.start();
         }
-        catch(Exception exception1) { }
+        catch(Exception e) {
+            LOGGER.error("Failed to start Resource Download Thread!", e);
+        }
         
         OpenGLHelper.checkError("post startup");
-        ingameGUI = new GuiIngame(this);
+        ingameHud = new IngameHud(this);
 
         new Registries();
 
@@ -537,8 +562,8 @@ public class Minecraft
         int groups = Registries.RECIPES.getAllGroups().size();
         int namespaces = Registries.RECIPES.size();
         int itemGroups = Registries.ITEM_GROUPS.size();
-        System.out.printf("%d item groups.%n",itemGroups);
-        System.out.printf("%d recipes in %d groups in %d namespaces.%n",recipes,groups,namespaces);
+        LOGGER.info(String.format("%d item groups.", itemGroups));
+        LOGGER.info(String.format("%d recipes in %d groups in %d namespaces.",recipes,groups,namespaces));
 
         StatList.init();
         statsCounter = new StatsCounter(session, mcDataDir);
@@ -577,28 +602,28 @@ public class Minecraft
         }
 
         if (!hasBeta173) {
-            displayGuiScreen(new GuiMissingMinecraft());
+            displayScreen(new MissingMinecraftScreen());
         }
         else if (System.getProperty("sun.arch.data.model").equals("32"))
         {
-            displayGuiScreen(new GuiBadJavaArch());
+            displayScreen(new BadJavaArchScreen());
         }
         else if(serverName != null)
         {
-            displayGuiScreen(new GuiConnecting(this, serverName, serverPort));
+            displayScreen(new ConnectingScreen(this, serverName, serverPort));
         }
         else if (worldPresetName != null && worldPresetSeed != null)
         {
-            GuiSelectWorld selectWorldScreen = new GuiSelectWorld(null);
-            displayGuiScreen(selectWorldScreen);
+            SelectWorldScreen selectWorldScreen = new SelectWorldScreen(null);
+            displayScreen(selectWorldScreen);
             selectWorldScreen.deletePresetWorld(worldPresetName);
-            GuiCreateWorld screen = new GuiCreateWorld(null);
-            displayGuiScreen(screen);
+            CreateWorldScreen screen = new CreateWorldScreen(null);
+            displayScreen(screen);
             screen.runPreset(worldPresetName, worldPresetSeed, worldPresetX, worldPresetY, worldPresetZ);
         }
         else
         {
-            displayGuiScreen(new GuiMainMenu());
+            displayScreen(new MainMenuScreen());
         }
         gameWindow.updateWindowState();
     }
@@ -609,20 +634,23 @@ public class Minecraft
     		return;
     	}
     	try {
-    		int major = Integer.parseInt(javaVersion.split(".")[0]);
+    		int major = Integer.parseInt(javaVersion.split("\\.")[0]);
     		if(major > 8) {
-    			System.out.println("Detected a probably incompatible Java version. If the game crashes with a message similar to \n"
+                LOGGER.warn("Detected a probably incompatible Java version. If the game crashes with a message similar to \n"
     					+ "\"Inconsistency detected by ld.so: dl-lookup.c: 111: check_match: Assertion `version->filename == NULL || ! _dl_name_match_p (version->filename, map)' failed!\", \n"
     					+ "use Java 8!");
     		}
     	}catch (Exception e) {
-    		e.printStackTrace();
+            LOGGER.error("Failed to retrieve Java version!", e);
+            LOGGER.warn("If the game crashes with a message similar to \n"
+                + "\"Inconsistency detected by ld.so: dl-lookup.c: 111: check_match: Assertion `version->filename == NULL || ! _dl_name_match_p (version->filename, map)' failed!\", \n"
+                + "use Java 8!");
 		}
     }
 
     private void loadScreen() throws LWJGLException
     {
-        System.out.println("Drawing Loading Screen...");
+        LOGGER.info("Drawing Loading Screen...");
         glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
         glMatrixMode(GL11.GL_PROJECTION);
         glLoadIdentity();
@@ -638,9 +666,9 @@ public class Minecraft
         glDisable(GL11.GL_FOG);
         
         if(mojrand == 0)
-            renderEngine.loadTexture("/assets/minecraft/textures/gui/title/majonk.png").bind();
+            textureManager.loadTexture("/assets/minecraft/textures/gui/title/majonk.png").bind();
         else
-            renderEngine.loadTexture("/assets/minecraft/textures/gui/title/mojang.png").bind();
+            textureManager.loadTexture("/assets/minecraft/textures/gui/title/mojang.png").bind();
         
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0xffffff);
@@ -671,10 +699,10 @@ public class Minecraft
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0xffffff);
-        tessellator.addVertexWithUV(minX + 0, minY + height, 0.0D, (float)(minU + 0) * scaleX, (float)(minV + height) * scaleY);
-        tessellator.addVertexWithUV(minX + width, minY + height, 0.0D, (float)(minU + width) * scaleX, (float)(minV + height) * scaleY);
-        tessellator.addVertexWithUV(minX + width, minY + 0, 0.0D, (float)(minU + width) * scaleX, (float)(minV + 0) * scaleY);
-        tessellator.addVertexWithUV(minX + 0, minY + 0, 0.0D, (float)(minU + 0) * scaleX, (float)(minV + 0) * scaleY);
+        tessellator.addVertexWithUV(minX + 0,       minY + height,  0.0D, (float)(minU + 0) * scaleX,       (float)(minV + height) * scaleY);
+        tessellator.addVertexWithUV(minX + width,   minY + height,  0.0D, (float)(minU + width) * scaleX,   (float)(minV + height) * scaleY);
+        tessellator.addVertexWithUV(minX + width,   minY + 0,       0.0D, (float)(minU + width) * scaleX,   (float)(minV + 0) * scaleY);
+        tessellator.addVertexWithUV(minX + 0,       minY + 0,       0.0D, (float)(minU + 0) * scaleX,       (float)(minV + 0) * scaleY);
         tessellator.draw();
     }
 
@@ -768,9 +796,9 @@ public class Minecraft
         return saveFormat;
     }
 
-    public void displayGuiScreen(GuiScreen guiscreen)
+    public void displayScreen(Screen screen)
     {
-        if(currentScreen == null && guiscreen != null)
+        if(currentScreen == null && screen != null)
         {
             if(controllerInput != null)
             {
@@ -780,32 +808,32 @@ public class Minecraft
         }
         if(currentScreen != null)
         {
-            currentScreen.onClosed();
+            currentScreen.removed();
         }
-        if(guiscreen instanceof GuiMainMenu)
+        if(screen instanceof MainMenuScreen)
         {
             statsCounter.fetchStats();
         }
         if(statsCounter != null){
             statsCounter.saveStats();
         }
-        if(guiscreen == null && theWorld == null)
+        if(screen == null && theWorld == null)
         {
-            guiscreen = new GuiMainMenu();
+            screen = new MainMenuScreen();
         }
-        else if(guiscreen == null && thePlayer.getHealth() <= 0)
+        else if(screen == null && thePlayer.getHealth() <= 0)
         {
-            guiscreen = new GuiGameOver();
+            screen = new GameOverScreen();
         }
-        if(guiscreen instanceof GuiMainMenu)
+        if(screen instanceof MainMenuScreen)
         {
-            ingameGUI.clearChatMessages();
+            ingameHud.clearChatMessages();
         }
-        currentScreen = guiscreen;
-        if(guiscreen != null)
+        currentScreen = screen;
+        if(screen != null)
         {
             setIngameNotInFocus();
-            guiscreen.setWorldAndResolution(this, resolution.scaledWidth, resolution.scaledHeight);
+            screen.init(this, resolution.scaledWidth, resolution.scaledHeight);
             skipRenderWorld = false;
         } else
         {
@@ -821,13 +849,13 @@ public class Minecraft
 					gameSettings.saveOptions();
 				}
 			}catch (Exception e) {
-				e.printStackTrace();
+                LOGGER.error("Exception occurred while saving settings! Some settings may be lost!", e);
 			}
 			if(statsCounter != null) {
                 statsCounter.fetchStats();
 				statsCounter.saveStats();
 			}
-			System.out.println("Stopping!");
+            LOGGER.info("Stopping!");
 			try {
 				changeWorld(null);
 			}catch (Throwable ignored) {
@@ -882,7 +910,7 @@ public class Minecraft
                     Vec3.initializePool();
                     
                     if(gameWindow.shouldClose()) shutdown();
-                    if(isGamePaused && theWorld != null && !(currentScreen instanceof GuiModelViewer))
+                    if(isGamePaused && theWorld != null && !(currentScreen instanceof ModelViewerScreen))
                     {
                         float temp = timer.partialTicks;
                         timer.advanceTime();
@@ -892,7 +920,6 @@ public class Minecraft
                         timer.advanceTime();
                     }
                     if (!doPartialTick) timer.partialTicks = 1f;
-                    long nanoTime = System.nanoTime();
 
                     mouseInput.update();
                     if(controllerInput != null && currentScreen != null)
@@ -914,9 +941,10 @@ public class Minecraft
                         catch(MinecraftException e)
                         {
                             theWorld = null;
+                            LOGGER.error("MinecraftException occurred while attempting to run tick, existing world!", e);
                         }
                         changeWorld(null);
-                        displayGuiScreen(new GuiConflictWarning());
+                        displayScreen(new ConflictWarningScreen());
                     }
                     
                     Debug.change("update"); // 1
@@ -972,7 +1000,7 @@ public class Minecraft
                         }
                     }
                     sndManager.setMuted(gameSettings.muteOnLostFocus.value && !gameWindow.isFocused());
-                    guiAchievementToast.render(timer.partialTicks);
+                    guiToasts.render(timer.partialTicks);
 
                     Debug.change("post");  // 3
                     renderer.endRenderGame(timer.partialTicks);
@@ -987,7 +1015,7 @@ public class Minecraft
                     }
                     OpenGLHelper.checkError("post render");
                     fpsCounter++;
-                    isGamePaused = !isMultiplayerWorld() && currentScreen != null && currentScreen.pausesGame();
+                    isGamePaused = !isMultiplayerWorld() && currentScreen != null && currentScreen.isPauseScreen();
                     while(System.currentTimeMillis() >= currentTime + 1000L)
                     {
                         debug = fpsCounter + " fps, " + ChunkRenderer.updates + " chunk updates";
@@ -1008,7 +1036,7 @@ public class Minecraft
 					Debug.pop();	// 2
 					Debug.pop();	// 1
 					if(gameSettings.showFrameTimes.value) {
-						DebugRender.render(fontRenderer);
+						DebugRender.render(font);
 					}
 					
                     screenshotListener();
@@ -1017,12 +1045,12 @@ public class Minecraft
                 {
                     theWorld = null;
                     changeWorld(null);
-                    displayGuiScreen(new GuiConflictWarning());
+                    displayScreen(new ConflictWarningScreen());
                 }
                 catch(OutOfMemoryError outofmemoryerror)
                 {
                     freeUpMemory();
-                    displayGuiScreen(new GuiOutOfMemory());
+                    displayScreen(new OutOfMemoryScreen());
                     System.gc();
                 }
                 catch(Throwable throwable)
@@ -1073,13 +1101,13 @@ public class Minecraft
 					if(Shaders.enableShaders) {
 						try {
 							screenshotHelper.takePanoramaScreenshot();
-							ingameGUI.addChatMessage("Saved panorama screenshot!");
+							ingameHud.addChatMessage("Saved panorama screenshot!");
 						}catch (Exception e) {
-							e.printStackTrace();
+                            LOGGER.error("Exception occurred while taking panoramic screenshot!", e);
 						}
 					}
 				}else {
-					ingameGUI.addChatMessage(ScreenShot.saveScreenshot(minecraftDir, resolution.width, resolution.height));	
+					ingameHud.addChatMessage(ScreenShot.saveScreenshot(minecraftDir, resolution.width, resolution.height));
 				}
 				Debug.pop();
 			}
@@ -1103,7 +1131,7 @@ public class Minecraft
         {
             inGameHasFocus = true;
             mouseInput.grabCursor();
-            displayGuiScreen(null);
+            displayScreen(null);
             mouseTicksRan = ticksRan + 10000;
             if(thePlayer != null) {
             	thePlayer.input.onGameFocused();
@@ -1130,7 +1158,7 @@ public class Minecraft
     {
         if(currentScreen == null)
         {
-            displayGuiScreen(new GuiIngameMenu());
+            displayScreen(new PauseScreen());
         }
     }
 
@@ -1288,7 +1316,7 @@ public class Minecraft
     {
         resolution.update();
         if(currentScreen != null) {
-            currentScreen.setWorldAndResolution(this, resolution.scaledWidth, resolution.scaledHeight);
+            currentScreen.init(this, resolution.scaledWidth, resolution.scaledHeight);
         }
     }
 
@@ -1319,7 +1347,7 @@ public class Minecraft
             }
             catch(Exception exception)
             {
-                exception.printStackTrace();
+                LOGGER.error("Error occurred while checking if paid client", exception);
             }
         }).start();
     }
@@ -1331,8 +1359,9 @@ public class Minecraft
             startCheckPaidThread();
         }
         Debug.push("gui");
+        subtitleTracker.tick();
         statsCounter.tick();
-        ingameGUI.updateTick();
+        ingameHud.updateTick();
         Debug.change("misc");
         worldRenderer.getMouseOver(1.0F);
         if(thePlayer != null)
